HDU——1069【Monkey and Banana】

【题意】:

有人要做实验,看看猴子的智商,在屋顶上边挂着吃的东西,然后给你一些木块的长、宽、高,问你猴子最高可以爬多高,下面的木块必须大于(不能等于)上面的木块。

【思考】:

感觉像贪心,但还要多一点dp的味道,如果你可以看出这是一个严格递增子序列的问题,那最好了,可惜我没看出来,所以用了dp,dp转移方程为:dp[i]=max( dp[i],dp[j]+hi[i]) ,所以开始码起来  ^_^ !

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food. 

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height. 

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked. 

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks. 

Input

The input file will contain one or more test cases. The first line of each test case contains an integer n, 
representing the number of different blocks in the following data set. The maximum value for n is 30. 
Each of the next n lines contains three integers representing the values xi, yi and zi. 
Input is terminated by a value of zero (0) for n. 

Output

For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height". 

Sample Input

扫描二维码关注公众号,回复: 3626854 查看本文章
1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0

Sample Output

Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342

ac代码:

记得长宽高要从小到大排一下序!!!

#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;

int n;
int dp[3000];
int a,b,c;

struct node{
	int l1,l2,hg;
}blk[3000];

bool cmp(node a,node b)
{
	if(a.l1>b.l1)	return true;
	if(a.l1==b.l1&&a.l2>b.l2 )	return true;
	else	return false;
}

int main()
{
	int ans,i,j,m=0,x,y,z;
	while(scanf("%d",&n)&&n)
	{
		memset(dp,0,sizeof(dp));
		int k=0;
		for(i=1;i<=n;i++)
		{
			scanf("%d%d%d",&a,&b,&c);
			x=a,y=b,z=c;
			a=min(x,min(y,z));
			c=max(x,max(y,z));
			int p=x+y+z;
			b=p-a-c;
			blk[k].l1 =a, blk[k].l2 =b; blk[k].hg=c;
			k++;
			blk[k].l1 =a, blk[k].l2 =c; blk[k].hg=b;
			k++;
			blk[k].l1 =b, blk[k].l2 =a; blk[k].hg=c;
			k++;
			blk[k].l1 =b, blk[k].l2 =c; blk[k].hg=a;
			k++;
			blk[k].l1 =c, blk[k].l2 =b; blk[k].hg=a;
			k++;
			blk[k].l1 =c, blk[k].l2 =a; blk[k].hg=b;
		}
		sort(blk,blk+k,cmp);
		ans=0;
		for(i=k-1;i>=0;i--){
			dp[i]=blk[i].hg;
			for(j=i+1;j<k;j++){
				if(blk[i].l1 >blk[j].l1 && blk[i].l2 >blk[j].l2)
				{
					dp[i]=max(dp[i],dp[j]+blk[i].hg);
				}	
			}
		}
		for(i=0;i<k;i++)	
			ans=max(ans,dp[i]);
		printf("Case %d: maximum height = %d\n",++m,ans);
	}
	return 0;
}

猜你喜欢

转载自blog.csdn.net/sf_yang35/article/details/82622606